//Datei: BINBCD16.C
// Wandelt eine 16Bit Binrzahl in BCD Bytes
//
// Nach dem Beispiel von Microchip CD
// Benutzen, nur nicht drber nachdenken !
//
// Holger Klabunde
// 22.04.2001
// Compiler PICCLite

#include "prozess.h"      /* Der verwendete Prozessor */
#include "protos.h"

//Input : 16 Bit Wert in B0=LSB,B1=MSB
//Output: 8 Bit Globale Register  R0,R1,R2
//        R0 = MSB, R2 = LSB
unsigned char B0,B1;
unsigned char R0,R1,R2;
unsigned char counter,tmp; //PICCLite nimmt keine localen Var bei #asm

void BinToBCD16()
{
// unsigned char counter,temp;
 
#asm
    bcf _STATUS,0   // clear the carry bit
	movlw 0x10     //16 Bits bearbeiten
	movwf _counter  //Schleifenzhler
	clrf _R0        //R0=0
	clrf _R1
	clrf _R2
loop16  rlf _B0     //Rotiere Bitweise durch Carry in R2,R1,R0
	rlf _B1
	rlf _R2
	rlf _R1
	rlf _R0
	decfsz _counter  //Nchstes Bit
	goto adjDEC16
	RETLW 0

adjDEC16
        movlw _R2        //Zeiger auf R2
	movwf _FSR       //in FSR fr indirekte Adressierung
	call adjBCD     //BCD-Korrektur
	movlw _R1        //Auch fr R1,R0
	movwf _FSR
	call adjBCD
	movlw _R0       
	movwf _FSR
	call adjBCD
	goto loop16     //Nchstes von den 16 Bits

//Register 0 zeigt auf R2,R1 oder R0
adjBCD  movlw 0x03     //Untere BCD-Stelle lade W mit 3
	addwf 0,W      //0x03 addieren zu R0,R1,R2 Ergebnis in W
	movwf _tmp     //W zwischenspeichern fr Test Bit D3
	btfsc _tmp,3   // test if result > 7
	movwf 0        //war grer 7, dann W in Ergebnis speichern

	movlw 0x30     //Das gleiche mit der oberen BCD-Stelle
	addwf 0,W
	movwf _tmp
	btfsc _tmp,7   // test if result > 0x7F
	movwf 0        // save as MSD
	RETLW 0        // Ergebnis in R0,R1,R2 zurckgeben
#endasm
}

//Zeigt ein BCD-Byte auf der LCD-Anzeige
//oder eine Hexadezimalzahl
void ShowBCD(unsigned char x)
{
 unsigned char nib;

 nib=(x>>4) &0x0F; //High-Nibble

 if(nib<10) nib+=0x30; //ASCII Zahlen
 else nib+=0x37;  //ASCII Grobuchst.
 LCDWriteByte(nib);

 nib=x&0x0F; //Low-Nibble
 if(nib<10) nib+=0x30; //ASCII Zahlen
 else nib+=0x37;  //ASCII Grobuchst.
 LCDWriteByte(nib);
}

